local me = CreateFrame("Frame")

me:RegisterEvent("CHAT_MSG_MONSTER_EMOTE")
me:RegisterEvent("CHAT_MSG_MONSTER_SAY")
me:RegisterEvent("CHAT_MSG_MONSTER_WHISPER")
me:RegisterEvent("QUEST_LOG_UPDATE")

me.listOfNames = {
     {"Ringo", "Yo! The goblin has fainted, throw some water on him, quick!!"},
     {"Kerlonian Evershade", "Darn it!  That lazy druid has fallen asleep again, time to use the horn!!!"},
     {"Shay", "That dippy night elf girl is chasing butterflies again, better ring the bell and call her back."},
	 {"Magwin"},
	 {"Kernobee"},
	 {"Arei"},
	 {"Injured Goblin Miner"},
	 {"Cork Gizelton"},
	 {"Alliance Deserter"},
	 {"Protectorate Demolitionist"},
	 {"Isla Starmane"},
	 {"Skyguard Prisoner"},
	 {"Ranger Lilatha"},
	 {"Captured Protectorate Vanguard"},
	 {"Lurgglbr"},
	 {"Kayra Longmane"},
	 {"Erland"},
	 {"Belnistrasz"},
	 {"Fhwoor"},
	 {"Injured Rainspeaker Oracle"},
	 {"Lakota Windsong"},
	 {"Gilthares Firebough"},
	 {"Ruul"},
	 {"Galen"},
	 {"Melizza Brimbuzzle"},
	 {"Bonker Togglevolt"},
	 {"Rigger Gizelton"},
	 {"Pao'ka Swiftmountain"},
	 {"Father Kamaros"},
	 {"Taelan Fordring"},
	 {"Crusader Johnson"},
	 {"Crusader Lamoof"},
	 {"Crusader Josephine"},
	 {"Maxx A. Million Mk. V"},
	 {"Mist"},
	 {"Grark Lorkrub"},
	 {"Kaya Flathoof"},
	 {"Arko'narin"},
	 {"OOX-09/HL"},
	 {"OOX-17/TN"},
	 {"OOX-22/FE"},
	 {"Dalinda Malem"},
	 {"Rin'ji"},
	 {"Drijya"},
	 {"Skywing"},
	 {"Cryo-Engineer Sha'heen"},
	 {"\"Stinky\" Ignatz"},
	 {"Professor Phizzlethorpe"},
	 {"Defias Traitor"},
	 {"Mag'har Captive"},
	 {"Kurenai Captive"},
	 {"Anchorite Truuen"},
	 {"Torek"},
	 {"Apothecary Hanes"},
	 {"Bessy"},
	 {"Willix the Importer"},
     {"A-Me 01", "The suicidal ape robot is charging off into the fray again, go defend her!"},
     --etc
}

function me.EventHandler(self, event, _, name)
      if event == "QUEST_LOG_UPDATE" then
           me.Time = time()
           return
      end
      for i = 1, #self.listOfNames do
           if name:find(self.listOfNames[i][1]) then
               -- only one warning per 20 seconds
               if (not me.Time) or (time() - me.Time > 20) then
                    me.Time = time()
                    PlaySound("RaidWarning")
                    local msg = self.listOfNames[i][2] or "Heads Up!  Your quest NPC needs help!!!"
                    RaidNotice_AddMessage(RaidWarningFrame, msg, ChatTypeInfo["RAID_WARNING"])
                    return
               end
           end
      end
end

me:SetScript("OnEvent", me.EventHandler)